/*!
 * @hippy/hippy-vue-next-style-parser v3.3.1
 * (Using Vue v3.4.15 and Hippy-Vue-Next v3.3.1)
 * Build at: Mon Aug 26 2024 14:48:41 GMT+0800 (中国标准时间)
 *
 * Tencent is pleased to support the open source community by making
 * Hippy available.
 *
 * Copyright (C) 2023-2024 THL A29 Limited, a Tencent company.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import { camelize } from '@vue/shared';

/*
 * Tencent is pleased to support the open source community by making
 * Hippy available.
 *
 * Copyright (C) 2017-2022 THL A29 Limited, a Tencent company.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const names = {
    transparent: 0x00000000,
    aliceblue: 0xf0f8ffff,
    antiquewhite: 0xfaebd7ff,
    aqua: 0x00ffffff,
    aquamarine: 0x7fffd4ff,
    azure: 0xf0ffffff,
    beige: 0xf5f5dcff,
    bisque: 0xffe4c4ff,
    black: 0x000000ff,
    blanchedalmond: 0xffebcdff,
    blue: 0x0000ffff,
    blueviolet: 0x8a2be2ff,
    brown: 0xa52a2aff,
    burlywood: 0xdeb887ff,
    burntsienna: 0xea7e5dff,
    cadetblue: 0x5f9ea0ff,
    chartreuse: 0x7fff00ff,
    chocolate: 0xd2691eff,
    coral: 0xff7f50ff,
    cornflowerblue: 0x6495edff,
    cornsilk: 0xfff8dcff,
    crimson: 0xdc143cff,
    cyan: 0x00ffffff,
    darkblue: 0x00008bff,
    darkcyan: 0x008b8bff,
    darkgoldenrod: 0xb8860bff,
    darkgray: 0xa9a9a9ff,
    darkgreen: 0x006400ff,
    darkgrey: 0xa9a9a9ff,
    darkkhaki: 0xbdb76bff,
    darkmagenta: 0x8b008bff,
    darkolivegreen: 0x556b2fff,
    darkorange: 0xff8c00ff,
    darkorchid: 0x9932ccff,
    darkred: 0x8b0000ff,
    darksalmon: 0xe9967aff,
    darkseagreen: 0x8fbc8fff,
    darkslateblue: 0x483d8bff,
    darkslategray: 0x2f4f4fff,
    darkslategrey: 0x2f4f4fff,
    darkturquoise: 0x00ced1ff,
    darkviolet: 0x9400d3ff,
    deeppink: 0xff1493ff,
    deepskyblue: 0x00bfffff,
    dimgray: 0x696969ff,
    dimgrey: 0x696969ff,
    dodgerblue: 0x1e90ffff,
    firebrick: 0xb22222ff,
    floralwhite: 0xfffaf0ff,
    forestgreen: 0x228b22ff,
    fuchsia: 0xff00ffff,
    gainsboro: 0xdcdcdcff,
    ghostwhite: 0xf8f8ffff,
    gold: 0xffd700ff,
    goldenrod: 0xdaa520ff,
    gray: 0x808080ff,
    green: 0x008000ff,
    greenyellow: 0xadff2fff,
    grey: 0x808080ff,
    honeydew: 0xf0fff0ff,
    hotpink: 0xff69b4ff,
    indianred: 0xcd5c5cff,
    indigo: 0x4b0082ff,
    ivory: 0xfffff0ff,
    khaki: 0xf0e68cff,
    lavender: 0xe6e6faff,
    lavenderblush: 0xfff0f5ff,
    lawngreen: 0x7cfc00ff,
    lemonchiffon: 0xfffacdff,
    lightblue: 0xadd8e6ff,
    lightcoral: 0xf08080ff,
    lightcyan: 0xe0ffffff,
    lightgoldenrodyellow: 0xfafad2ff,
    lightgray: 0xd3d3d3ff,
    lightgreen: 0x90ee90ff,
    lightgrey: 0xd3d3d3ff,
    lightpink: 0xffb6c1ff,
    lightsalmon: 0xffa07aff,
    lightseagreen: 0x20b2aaff,
    lightskyblue: 0x87cefaff,
    lightslategray: 0x778899ff,
    lightslategrey: 0x778899ff,
    lightsteelblue: 0xb0c4deff,
    lightyellow: 0xffffe0ff,
    lime: 0x00ff00ff,
    limegreen: 0x32cd32ff,
    linen: 0xfaf0e6ff,
    magenta: 0xff00ffff,
    maroon: 0x800000ff,
    mediumaquamarine: 0x66cdaaff,
    mediumblue: 0x0000cdff,
    mediumorchid: 0xba55d3ff,
    mediumpurple: 0x9370dbff,
    mediumseagreen: 0x3cb371ff,
    mediumslateblue: 0x7b68eeff,
    mediumspringgreen: 0x00fa9aff,
    mediumturquoise: 0x48d1ccff,
    mediumvioletred: 0xc71585ff,
    midnightblue: 0x191970ff,
    mintcream: 0xf5fffaff,
    mistyrose: 0xffe4e1ff,
    moccasin: 0xffe4b5ff,
    navajowhite: 0xffdeadff,
    navy: 0x000080ff,
    oldlace: 0xfdf5e6ff,
    olive: 0x808000ff,
    olivedrab: 0x6b8e23ff,
    orange: 0xffa500ff,
    orangered: 0xff4500ff,
    orchid: 0xda70d6ff,
    palegoldenrod: 0xeee8aaff,
    palegreen: 0x98fb98ff,
    paleturquoise: 0xafeeeeff,
    palevioletred: 0xdb7093ff,
    papayawhip: 0xffefd5ff,
    peachpuff: 0xffdab9ff,
    peru: 0xcd853fff,
    pink: 0xffc0cbff,
    plum: 0xdda0ddff,
    powderblue: 0xb0e0e6ff,
    purple: 0x800080ff,
    rebeccapurple: 0x663399ff,
    red: 0xff0000ff,
    rosybrown: 0xbc8f8fff,
    royalblue: 0x4169e1ff,
    saddlebrown: 0x8b4513ff,
    salmon: 0xfa8072ff,
    sandybrown: 0xf4a460ff,
    seagreen: 0x2e8b57ff,
    seashell: 0xfff5eeff,
    sienna: 0xa0522dff,
    silver: 0xc0c0c0ff,
    skyblue: 0x87ceebff,
    slateblue: 0x6a5acdff,
    slategray: 0x708090ff,
    slategrey: 0x708090ff,
    snow: 0xfffafaff,
    springgreen: 0x00ff7fff,
    steelblue: 0x4682b4ff,
    tan: 0xd2b48cff,
    teal: 0x008080ff,
    thistle: 0xd8bfd8ff,
    tomato: 0xff6347ff,
    turquoise: 0x40e0d0ff,
    violet: 0xee82eeff,
    wheat: 0xf5deb3ff,
    white: 0xffffffff,
    whitesmoke: 0xf5f5f5ff,
    yellow: 0xffff00ff,
    yellowgreen: 0x9acd32ff,
};
const convertRegExp = (...args) => `\\(\\s*(${args.join(')\\s*,\\s*(')})\\s*\\)`;
const NUMBER = '[-+]?\\d*\\.?\\d+';
const PERCENTAGE = `${NUMBER}%`;
const matchers = {
    rgb: new RegExp(`rgb${convertRegExp(NUMBER, NUMBER, NUMBER)}`),
    rgba: new RegExp(`rgba${convertRegExp(NUMBER, NUMBER, NUMBER, NUMBER)}`),
    hsl: new RegExp(`hsl${convertRegExp(NUMBER, PERCENTAGE, PERCENTAGE)}`),
    hsla: new RegExp(`hsla${convertRegExp(NUMBER, PERCENTAGE, PERCENTAGE, NUMBER)}`),
    hex3: /^#([0-9a-fA-F])([0-9a-fA-F])([0-9a-fA-F])$/,
    hex4: /^#([0-9a-fA-F])([0-9a-fA-F])([0-9a-fA-F])([0-9a-fA-F])$/,
    hex6: /^#([0-9a-fA-F]{6})$/,
    hex8: /^#([0-9a-fA-F]{8})$/,
};
const parse255 = (str) => {
    const int = parseInt(str, 10);
    if (int < 0) {
        return 0;
    }
    if (int > 255) {
        return 255;
    }
    return int;
};
const parse1 = (str) => {
    const num = parseFloat(str);
    if (num < 0) {
        return 0;
    }
    if (num > 1) {
        return 255;
    }
    return Math.round(num * 255);
};
const hue2rgb = (p, q, tx) => {
    let t = tx;
    if (t < 0) {
        t += 1;
    }
    if (t > 1) {
        t -= 1;
    }
    if (t < 1 / 6) {
        return p + (q - p) * 6 * t;
    }
    if (t < 1 / 2) {
        return q;
    }
    if (t < 2 / 3) {
        return p + (q - p) * (2 / 3 - t) * 6;
    }
    return p;
};
const hslToRgb = (h, s, l) => {
    const q = l < 0.5 ? l * (1 + s) : l + s - l * s;
    const p = 2 * l - q;
    const r = hue2rgb(p, q, h + 1 / 3);
    const g = hue2rgb(p, q, h);
    const b = hue2rgb(p, q, h - 1 / 3);
    return ((Math.round(r * 255) << 24)
        | (Math.round(g * 255) << 16)
        | (Math.round(b * 255) << 8));
};
const parse360 = (str) => {
    const int = parseFloat(str);
    return (((int % 360) + 360) % 360) / 360;
};
const parsePercentage = (str) => {
    const int = parseFloat(str);
    if (int < 0) {
        return 0;
    }
    if (int > 100) {
        return 1;
    }
    return int / 100;
};
// eslint-disable-next-line complexity
function baseColor(color) {
    let match;
    if (typeof color === 'number') {
        if (color >>> 0 === color && color >= 0 && color <= 0xffffffff) {
            return color;
        }
        return null;
    }
    match = matchers.hex6.exec(color);
    if (Array.isArray(match)) {
        return parseInt(`${match[1]}ff`, 16) >>> 0;
    }
    if (Object.hasOwnProperty.call(names, color)) {
        return names[color];
    }
    match = matchers.rgb.exec(color);
    if (Array.isArray(match)) {
        return (((parse255(match[1]) << 24) // r
            | (parse255(match[2]) << 16) // g
            | (parse255(match[3]) << 8) // b
            | 0x000000ff) // a
            >>> 0);
    }
    match = matchers.rgba.exec(color);
    if (match) {
        return (((parse255(match[1]) << 24) // r
            | (parse255(match[2]) << 16) // g
            | (parse255(match[3]) << 8) // b
            | parse1(match[4])) // a
            >>> 0);
    }
    match = matchers.hex3.exec(color);
    if (match) {
        return (parseInt(`${match[1]
            + match[1] // r
            + match[2]
            + match[2] // g
            + match[3]
            + match[3] // b
        }ff`, // a
        16) >>> 0);
    }
    match = matchers.hex8.exec(color);
    if (match) {
        return parseInt(match[1], 16) >>> 0;
    }
    match = matchers.hex4.exec(color);
    if (match) {
        return (parseInt(match[1]
            + match[1] // r
            + match[2]
            + match[2] // g
            + match[3]
            + match[3] // b
            + match[4]
            + match[4], // a
        16) >>> 0);
    }
    match = matchers.hsl.exec(color);
    if (match) {
        return ((hslToRgb(parse360(match[1]), // h
        parsePercentage(match[2]), // s
        parsePercentage(match[3]))
            | 0x000000ff) // a
            >>> 0);
    }
    match = matchers.hsla.exec(color);
    if (match) {
        return ((hslToRgb(parse360(match[1]), // h
        parsePercentage(match[2]), // s
        parsePercentage(match[3]))
            | parse1(match[4])) // a
            >>> 0);
    }
    return null;
}
/**
 * Convert css color value or string description to native supported color format
 *
 * @param color - color value or string description
 *
 * @public
 */
function translateColor(color) {
    let int32Color = baseColor(color);
    if (int32Color === null) {
        throw new Error(`Bad color value: ${color}`);
    }
    int32Color = ((int32Color << 24) | (int32Color >>> 8)) >>> 0;
    return int32Color;
}

/*
 * Tencent is pleased to support the open source community by making
 * Hippy available.
 *
 * Copyright (C) 2017-2022 THL A29 Limited, a Tencent company.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * properties map
 *
 * @public
 */
const PROPERTIES_MAP = {
    textDecoration: 'textDecorationLine',
    boxShadowOffset: 'shadowOffset',
    boxShadowOffsetX: 'shadowOffsetX',
    boxShadowOffsetY: 'shadowOffsetY',
    boxShadowOpacity: 'shadowOpacity',
    boxShadowRadius: 'shadowRadius',
    boxShadowSpread: 'shadowSpread',
    boxShadowColor: 'shadowColor',
};
// linear-gradient direction description map
const LINEAR_GRADIENT_DIRECTION_MAP = {
    totop: '0',
    totopright: 'totopright',
    toright: '90',
    tobottomright: 'tobottomright',
    tobottom: '180',
    tobottomleft: 'tobottomleft',
    toleft: '270',
    totopleft: 'totopleft',
};
// degree unit
const DEGREE_UNIT = {
    TURN: 'turn',
    RAD: 'rad',
    DEG: 'deg',
};
// regular expression of comment
const commentRegexp = /\/\*.{0,1000}?\*\//gms;
/**
 * Output warning debug information to console
 *
 * @param context - output content
 */
function warn(...context) {
    if (process.env.NODE_ENV === 'production') {
        return;
    }
    // eslint-disable-next-line no-console
    console.warn(...context);
}
// regular expression of number
const numberRegEx$1 = new RegExp('^(?=.+)[+-]?\\d*\\.?\\d*([Ee][+-]?\\d+)?$');
/**
 * convert to number
 * @param str - target string or number
 */
function tryConvertNumber$1(str) {
    if (typeof str === 'number') {
        return str;
    }
    if (numberRegEx$1.test(str)) {
        try {
            return parseFloat(str);
        }
        catch (err) {
            // pass
        }
    }
    return str;
}
/**
 * Convert the px unit value to the pt unit value used by the native
 *
 * @param value - target px unit value
 */
function convertPxUnitToPt(value) {
    // If value is number just ignore
    if (Number.isInteger(value)) {
        return value;
    }
    // If value unit is px, change to use pt as 1:1.
    if (typeof value === 'string' && value.endsWith('px')) {
        const num = parseFloat(value.slice(0, value.indexOf('px')));
        if (!Number.isNaN(num)) {
            value = num;
        }
    }
    return value;
}
/**
 * Convert the angle value of a string to an angle value
 *
 * @param value - target value
 * @param unit - unit type
 *
 * @public
 */
function convertToDegree(value, unit = DEGREE_UNIT.DEG) {
    const convertedNumValue = parseFloat(value);
    let result = value || '';
    const [, decimals] = value.split('.');
    if (decimals && decimals.length > 2) {
        result = convertedNumValue.toFixed(2);
    }
    switch (unit) {
        // turn unit
        case DEGREE_UNIT.TURN:
            result = `${(convertedNumValue * 360).toFixed(2)}`;
            break;
        // radius unit
        case DEGREE_UNIT.RAD:
            result = `${((180 / Math.PI) * convertedNumValue).toFixed(2)}`;
            break;
    }
    return result;
}
/**
 * Get the angle value of the linear gradient
 *
 * @param value - target value
 *
 * @public
 */
function getLinearGradientAngle(value) {
    const processedValue = (value || '').replace(/\s*/g, '').toLowerCase();
    const reg = /^([+-]?(?=(?<digit>\d+))\k<digit>\.?\d*)+(deg|turn|rad)|(to\w+)$/g;
    const valueList = reg.exec(processedValue);
    if (!Array.isArray(valueList))
        return '';
    // default direction is to bottom, i.e. 180degree
    let angle = '180';
    const [direction, angleValue, angleUnit] = valueList;
    if (angleValue && angleUnit) {
        // handling values of type angular
        angle = convertToDegree(angleValue, angleUnit);
    }
    else if (direction
        && typeof LINEAR_GRADIENT_DIRECTION_MAP[direction] !== 'undefined') {
        // direct direction
        angle = LINEAR_GRADIENT_DIRECTION_MAP[direction];
    }
    else {
        warn('linear-gradient direction or angle is invalid, default value [to bottom] would be used');
    }
    return angle;
}
/**
 * Get the color value of the linear gradient when it stops
 *
 * @param value - color
 *
 * @public
 */
function getLinearGradientColorStop(value = '') {
    const processedValue = value.replace(/\s+/g, ' ').trim();
    const [color, percentage] = processedValue.split(/\s+(?![^(]*?\))/);
    const percentageCheckReg = /^([+-]?\d+\.?\d*)%$/g;
    if (color && !percentageCheckReg.exec(color) && !percentage) {
        return {
            color: translateColor(color),
        };
    }
    if (color && percentageCheckReg.exec(percentage)) {
        return {
            // color stop ratio
            ratio: parseFloat(percentage.split('%')[0]) / 100,
            color: translateColor(color),
        };
    }
    return null;
}
/**
 * parse background image style attribute
 *
 * @param property - property name
 * @param value - property value
 *
 * @public
 */
function parseBackgroundImage(property, value) {
    let processedValue = value;
    let processedProperty = property;
    if (value.indexOf('linear-gradient') === 0) {
        processedProperty = 'linearGradient';
        const valueString = value.substring(value.indexOf('(') + 1, value.lastIndexOf(')'));
        const tokens = valueString.split(/,(?![^(]*?\))/);
        const colorStopList = [];
        processedValue = {};
        tokens.forEach((token, index) => {
            if (index === 0) {
                // the angle of linear-gradient parameter can be optional
                const angle = getLinearGradientAngle(token);
                if (angle) {
                    processedValue.angle = angle;
                }
                else {
                    // if angle ignored, default direction is to bottom, i.e. 180degree
                    processedValue.angle = '180';
                    const colorObject = getLinearGradientColorStop(token);
                    if (colorObject)
                        colorStopList.push(colorObject);
                }
            }
            else {
                const colorObject = getLinearGradientColorStop(token);
                if (colorObject)
                    colorStopList.push(colorObject);
            }
        });
        processedValue.colorStopList = colorStopList;
    }
    else {
        const regexp = /(?:\(['"]?)(.*?)(?:['"]?\))/;
        const executed = regexp.exec(value);
        if (executed && executed.length > 1) {
            [, processedValue] = executed;
        }
    }
    return [processedProperty, processedValue];
}
/**
 * Recursively add non-enumerable parent nodes
 *
 * @param obj - target object
 * @param parent - parent node
 */
function addParent(obj, parent) {
    const isNode = obj && typeof obj.type === 'string';
    const childParent = isNode ? obj : parent;
    // Take all the keys of the node, and judge the value, if it is an array and an object, then recursively addParent
    Object.keys(obj).forEach((k) => {
        const value = obj[k];
        if (Array.isArray(value)) {
            value.forEach((v) => {
                addParent(v, childParent);
            });
        }
        else if (value && typeof value === 'object') {
            addParent(value, childParent);
        }
    });
    // If it is a node type, add a parent node, if no parent node is passed in, set it to null
    if (isNode) {
        Object.defineProperty(obj, 'parent', {
            configurable: true,
            writable: true,
            enumerable: false,
            value: parent,
        });
    }
    return obj;
}
/**
 * parse css code into AST tree
 *
 * @param css - css code
 * @param options - parse options
 *
 * @public
 */
function parseCSS(css, options = { source: 0 }) {
    // position
    let lineno = 1;
    let column = 1;
    /**
     * update lineno and column
     */
    function updatePosition(str) {
        const lines = str.match(/\n/g);
        if (lines)
            lineno += lines.length;
        const i = str.lastIndexOf('\n');
        column = ~i ? str.length - i : column + str.length;
    }
    /**
     * Match `re` and return captures.
     */
    function match(re) {
        const m = re.exec(css);
        if (!m) {
            return null;
        }
        const str = m[0];
        updatePosition(str);
        css = css.slice(str.length);
        return m;
    }
    /**
     * Remove the whitespace at the beginning of css and update the location information
     */
    function whitespace() {
        match(/^\s*/);
    }
    /**
     * Record the position and set the value of node.position
     */
    function position() {
        return (node) => {
            node.position = {
                start: { line: lineno, column },
                end: { line: lineno, column },
                source: options.source,
                content: css,
            };
            whitespace();
            return node;
        };
    }
    const errorsList = [];
    function error(msg) {
        const errorInstance = new Error(`${options.source}:${lineno}:${column}: ${msg}`);
        const newError = {
            ...errorInstance,
            reason: msg,
            filename: options.source,
            line: lineno,
            column,
            source: css,
        };
        if (options.silent) {
            errorsList.push(newError);
        }
        else {
            throw newError;
        }
    }
    /**
     * Parse comment.
     */
    function comment() {
        const pos = position();
        if (css.charAt(0) !== '/' || css.charAt(1) !== '*') {
            return null;
        }
        let i = 2;
        while (css.charAt(i) !== ''
            && (css.charAt(i) !== '*' || css.charAt(i + 1) !== '/')) {
            i += 1;
        }
        i += 2;
        if (css.charAt(i - 1) === '') {
            return error('End of comment missing');
        }
        const str = css.slice(2, i - 2);
        column += 2;
        updatePosition(str);
        css = css.slice(i);
        column += 2;
        return pos({
            type: 'comment',
            comment: str,
        });
    }
    /**
     * Parse comments;
     */
    function comments(rawRules = []) {
        let c;
        const commentRules = rawRules || [];
        while ((c = comment())) {
            if (c !== false) {
                commentRules.push(c);
            }
        }
        return commentRules;
    }
    /**
     * Generate rule set
     */
    function rules() {
        let node;
        const actualRules = [];
        whitespace();
        comments(actualRules);
        // eslint-disable-next-line @typescript-eslint/no-use-before-define
        while (css.length && css.charAt(0) !== '}' && (node = atrule() || rule())) {
            if (node) {
                actualRules.push(node);
                comments(actualRules);
            }
        }
        return actualRules;
    }
    /**
     * Process the stylesheet and get a list of rules
     */
    function stylesheet() {
        const rulesList = rules();
        return {
            type: 'stylesheet',
            stylesheet: {
                source: options.source,
                rules: rulesList,
                parsingErrors: errorsList,
            },
        };
    }
    /**
     * Remove whitespace between opening brace and content
     */
    function open() {
        return match(/^{\s*/);
    }
    /**
     * Remove whitespace between closing brace and content
     */
    function close() {
        return match(/^}/);
    }
    /**
     * Parse selector.
     */
    function selector() {
        const matched = match(/^([^{]+)/);
        if (!matched) {
            return null;
        }
        /* @fix Remove all comments from selectors like #root .result /* df *\/ div
         * http://ostermiller.org/findcomment.html */
        return matched[0]
            .trim()
            .replace(/\/\*([^*]|[\r\n]|(\*+([^*/]|[\r\n])))*\*\/+/g, '')
            .replace(/"(?:\\"|[^"])*"|'(?:\\'|[^'])*'/g, m => m.replace(/,/g, '\u200C'))
            .split(/\s*(?![^(]*\)),\s*/)
            .map(s => s.replace(/\u200C/g, ','));
    }
    /**
     * Parse declaration.
     */
    // eslint-disable-next-line complexity
    function declaration() {
        const pos = position();
        // prop
        let prop = match(/^(\*?[-#/*\\\w]+(\[[0-9a-z_-]+])?)\s*/);
        if (!prop) {
            return null;
        }
        prop = prop[0].trim();
        // :
        if (!match(/^:\s*/)) {
            return error('property missing \':\'');
        }
        // val
        const propertyName = prop.replace(commentRegexp, '');
        const camelizeProperty = camelize(propertyName);
        let property = (() => {
            const mapProperty = PROPERTIES_MAP[camelizeProperty];
            if (mapProperty) {
                return mapProperty;
            }
            return camelizeProperty;
        })();
        const val = match(/^((?:'(?:\\'|.)*?'|"(?:\\"|.)*?"|\([^)]{0,500}?\)|[^};])+)/);
        let value = val ? val[0].trim().replace(commentRegexp, '') : '';
        switch (property) {
            case 'backgroundImage': {
                [property, value] = parseBackgroundImage(property, value);
                break;
            }
            case 'transform': {
                const keyReg = /((\w+)\s*\()/;
                const valueReg = /(?:\(['"]?)(.*?)(?:['"]?\))/;
                const oldValue = value;
                value = [];
                oldValue.split(' ').forEach((transformKeyValue) => {
                    if (keyReg.test(transformKeyValue)) {
                        let key;
                        let v;
                        const matchedKey = keyReg.exec(transformKeyValue);
                        const matchedValue = valueReg.exec(transformKeyValue);
                        if (matchedKey) {
                            [, , key] = matchedKey;
                        }
                        if (matchedValue) {
                            [, v] = matchedValue;
                        }
                        if (v.indexOf('.') === 0) {
                            v = `0${v}`;
                        }
                        if (parseFloat(v).toString() === v) {
                            v = parseFloat(v);
                        }
                        const transform = {};
                        transform[key] = v;
                        value.push(transform);
                    }
                    else {
                        error('missing \'(\'');
                    }
                });
                break;
            }
            case 'fontWeight':
                // Keep string and going on.
                break;
            case 'shadowOffset': {
                const declarationPos = value
                    .split(' ')
                    .filter(v => v)
                    .map(v => convertPxUnitToPt(v));
                const [x] = declarationPos;
                let [, y] = declarationPos;
                if (!y) {
                    y = x;
                }
                // FIXME: should not be width and height, should be x and y.
                value = {
                    x,
                    y,
                };
                break;
            }
            case 'collapsable':
                value = Boolean(value);
                break;
            default: {
                value = tryConvertNumber$1(value);
                // Convert the px to pt for specific properties
                const sizeProperties = [
                    'top',
                    'left',
                    'right',
                    'bottom',
                    'height',
                    'width',
                    'size',
                    'padding',
                    'margin',
                    'ratio',
                    'radius',
                    'offset',
                    'spread',
                ];
                if (sizeProperties.find(size => property.toLowerCase().indexOf(size) > -1)) {
                    value = convertPxUnitToPt(value);
                }
            }
        }
        const ret = pos({
            type: 'declaration',
            value,
            property,
        });
        match(/^[;\s]*/);
        return ret;
    }
    /**
     * Parse declarations.
     */
    function declarations() {
        let decls = [];
        if (!open())
            return error('missing \'{\'');
        comments(decls);
        // declarations
        let decl;
        while ((decl = declaration())) {
            if (decl !== false) {
                if (Array.isArray(decl)) {
                    decls = decls.concat(decl);
                }
                else {
                    decls.push(decl);
                }
                comments(decls);
            }
        }
        if (!close())
            return error('missing \'}\'');
        return decls;
    }
    /**
     * Parse rule.
     */
    function rule() {
        const pos = position();
        const sel = selector();
        if (!sel)
            return error('selector missing');
        comments();
        return pos({
            type: 'rule',
            selectors: sel,
            declarations: declarations(),
        });
    }
    /**
     * Parse keyframe.
     */
    function keyframe() {
        let m;
        const vals = [];
        const pos = position();
        while ((m = match(/^((\d+\.\d+|\.\d+|\d+)%?|[a-z]+)\s*/))) {
            vals.push(m[1]);
            match(/^,\s*/);
        }
        if (!vals.length) {
            return null;
        }
        return pos({
            type: 'keyframe',
            values: vals,
            declarations: declarations(),
        });
    }
    /**
     * Parse keyframes.
     */
    function atkeyframes() {
        const pos = position();
        let m = match(/^@([-\w]+)?keyframes\s*/);
        if (!m) {
            return null;
        }
        const vendor = m[1];
        // identifier
        m = match(/^([-\w]+)\s*/);
        if (!m) {
            return error('@keyframes missing name');
        }
        const name = m[1];
        if (!open())
            return error('@keyframes missing \'{\'');
        let frame;
        let frames = comments();
        while ((frame = keyframe())) {
            frames.push(frame);
            frames = frames.concat(comments());
        }
        if (!close())
            return error('@keyframes missing \'}\'');
        return pos({
            type: 'keyframes',
            name,
            vendor,
            keyframes: frames,
        });
    }
    /**
     * Parse supports.
     */
    function atsupports() {
        const pos = position();
        const m = match(/^@supports *([^{]+)/);
        if (!m) {
            return null;
        }
        const supports = m[1].trim();
        if (!open())
            return error('@supports missing \'{\'');
        const style = comments().concat(rules());
        if (!close())
            return error('@supports missing \'}\'');
        return pos({
            type: 'supports',
            supports,
            rules: style,
        });
    }
    /**
     * Parse host.
     */
    function athost() {
        const pos = position();
        const m = match(/^@host\s*/);
        if (!m) {
            return null;
        }
        if (!open()) {
            return error('@host missing \'{\'');
        }
        const style = comments().concat(rules());
        if (!close()) {
            return error('@host missing \'}\'');
        }
        return pos({
            type: 'host',
            rules: style,
        });
    }
    /**
     * Parse media.
     */
    function atmedia() {
        const pos = position();
        const m = match(/^@media *([^{]+)/);
        if (!m) {
            return null;
        }
        const media = m[1].trim();
        if (!open()) {
            return error('@media missing \'{\'');
        }
        const style = comments().concat(rules());
        if (!close()) {
            return error('@media missing \'}\'');
        }
        return pos({
            type: 'media',
            media,
            rules: style,
        });
    }
    /**
     * Parse custom-media.
     */
    function atcustommedia() {
        const pos = position();
        const m = match(/^@custom-media\s+(--[^\s]+)\s*([^{;]{1,200}?);/);
        if (!m) {
            return null;
        }
        return pos({
            type: 'custom-media',
            name: m[1].trim(),
            media: m[2].trim(),
        });
    }
    /**
     * Parse paged media.
     */
    function atpage() {
        const pos = position();
        const m = match(/^@page */);
        if (!m) {
            return null;
        }
        const sel = selector() || [];
        if (!open()) {
            return error('@page missing \'{\'');
        }
        let decls = comments();
        // declarations
        let decl;
        while ((decl = declaration())) {
            decls.push(decl);
            decls = decls.concat(comments());
        }
        if (!close()) {
            return error('@page missing \'}\'');
        }
        return pos({
            type: 'page',
            selectors: sel,
            declarations: decls,
        });
    }
    /**
     * Parse document.
     */
    function atdocument() {
        const pos = position();
        const m = match(/^@([-\w]+)?document *([^{]+)/);
        if (!m) {
            return null;
        }
        const vendor = m[1].trim();
        const doc = m[2].trim();
        if (!open()) {
            return error('@document missing \'{\'');
        }
        const style = comments().concat(rules());
        if (!close()) {
            return error('@document missing \'}\'');
        }
        return pos({
            type: 'document',
            document: doc,
            vendor,
            rules: style,
        });
    }
    /**
     * Parse font-face.
     */
    function atfontface() {
        const pos = position();
        const m = match(/^@font-face\s*/);
        if (!m) {
            return null;
        }
        if (!open()) {
            return error('@font-face missing \'{\'');
        }
        let decls = comments();
        // declarations
        let decl;
        while ((decl = declaration())) {
            decls.push(decl);
            decls = decls.concat(comments());
        }
        if (!close()) {
            return error('@font-face missing \'}\'');
        }
        return pos({
            type: 'font-face',
            declarations: decls,
        });
    }
    /**
     * Parse non-block at-rules
     */
    function compileAtRule(name) {
        const re = new RegExp(`^@${name}\\s*([^;]+);`);
        return () => {
            const pos = position();
            const m = match(re);
            if (!m) {
                return null;
            }
            const ret = { type: name };
            ret[name] = m[1].trim();
            return pos(ret);
        };
    }
    /**
     * Parse import
     */
    const atimport = compileAtRule('import');
    /**
     * Parse charset
     */
    const atcharset = compileAtRule('charset');
    /**
     * Parse namespace
     */
    const atnamespace = compileAtRule('namespace');
    /**
     * Parse at rule.
     */
    // eslint-disable-next-line complexity
    function atrule() {
        if (css[0] !== '@') {
            return null;
        }
        return (atkeyframes()
            || atmedia()
            || atcustommedia()
            || atsupports()
            || atimport()
            || atcharset()
            || atnamespace()
            || atdocument()
            || atpage()
            || athost()
            || atfontface());
    }
    return addParent(stylesheet(), null);
}

/*
 * Tencent is pleased to support the open source community by making
 * Hippy available.
 *
 * Copyright (C) 2022 THL A29 Limited, a Tencent company.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * stores the Selector list matched by the node
 */
class SelectorsMatch {
    constructor() {
        this.changeMap = new Map();
    }
    /**
     * Add attribute
     *
     * @param node - target node
     * @param attribute - attribute name
     */
    addAttribute(node, attribute) {
        const deps = this.properties(node);
        if (!deps.attributes) {
            deps.attributes = new Set();
        }
        deps.attributes.add(attribute);
    }
    /**
     * add pseudo class
     *
     * @param node - target node
     * @param pseudoClass - pseudo class
     */
    addPseudoClass(node, pseudoClass) {
        const deps = this.properties(node);
        if (!deps.pseudoClasses) {
            deps.pseudoClasses = new Set();
        }
        deps.pseudoClasses.add(pseudoClass);
    }
    properties(node) {
        let set = this.changeMap.get(node);
        if (!set) {
            this.changeMap.set(node, (set = {}));
        }
        return set;
    }
}
/**
 * selectors map class
 *
 * @public
 *
 */
class SelectorsMap {
    constructor(ruleSets) {
        this.id = {};
        this.class = {};
        this.type = {};
        this.universal = [];
        this.position = 0;
        this.ruleSets = ruleSets;
        ruleSets.forEach(rule => rule.lookupSort(this));
    }
    /**
     * Remove the specified style from the style rules map
     *
     * @param map - style map
     * @param head - style key
     * @param sel - selector
     */
    static removeFromMap(map, head, sel) {
        const list = map[head];
        const index = list.findIndex(item => { var _a; return item.sel.ruleSet.hash === ((_a = sel.ruleSet) === null || _a === void 0 ? void 0 : _a.hash); });
        if (index !== -1) {
            list.splice(index, 1);
        }
    }
    /**
     * Append a new list of style rules
     *
     * @param appendRules - list of style rules
     */
    append(appendRules) {
        this.ruleSets = this.ruleSets.concat(appendRules);
        appendRules.forEach(rule => rule.lookupSort(this));
    }
    /**
     * Find the style in the list of style rules according to the hash value and delete it
     *
     * @param hash - hash of style chunk
     */
    delete(hash) {
        const removeRuleSets = [];
        // Find the style in the list of style rules according to the hash value
        this.ruleSets = this.ruleSets.filter((rule) => {
            if (rule.hash !== hash) {
                return true;
            }
            removeRuleSets.push(rule);
            return false;
        });
        // Call the remove rule api to remove the deactivated style rule
        removeRuleSets.forEach(rule => rule.removeSort(this));
    }
    /**
     * Find the matching style information according to the id, class, attribute of the hippy node
     *
     * @param node - target node
     * @param ssrNodes - ssr node list
     */
    query(node, ssrNodes) {
        const { tagName, id, classList, props } = node;
        let domId = id;
        let domClassList = classList;
        if (props === null || props === void 0 ? void 0 : props.attributes) {
            // props and attributes exist means this node is generated from server side(except development).
            // so we need to use these props first
            const { attributes } = props;
            domClassList = new Set(((attributes === null || attributes === void 0 ? void 0 : attributes.class) || '').split(' ').filter(x => x.trim()));
            domId = attributes.id;
        }
        const selectorClasses = [this.universal, this.id[domId], this.type[tagName]];
        if (domClassList === null || domClassList === void 0 ? void 0 : domClassList.size) {
            domClassList.forEach(c => selectorClasses.push(this.class[c]));
        }
        const selectors = selectorClasses
            .filter(arr => !!arr)
            .reduce((cur, next) => cur.concat(next), []);
        const selectorsMatch = new SelectorsMatch();
        selectorsMatch.selectors = selectors
            .filter(sel => sel.sel.accumulateChanges(node, selectorsMatch, ssrNodes))
            .sort((a, b) => a.sel.specificity - b.sel.specificity || a.pos - b.pos)
            .map(docSel => docSel.sel);
        return selectorsMatch;
    }
    removeById(id, sel) {
        SelectorsMap.removeFromMap(this.id, id, sel);
    }
    sortById(id, sel) {
        this.addToMap(this.id, id, sel);
    }
    removeByClass(cssClass, sel) {
        SelectorsMap.removeFromMap(this.class, cssClass, sel);
    }
    sortByClass(cssClass, sel) {
        this.addToMap(this.class, cssClass, sel);
    }
    removeByType(cssType, sel) {
        SelectorsMap.removeFromMap(this.type, cssType, sel);
    }
    sortByType(cssType, sel) {
        this.addToMap(this.type, cssType, sel);
    }
    removeAsUniversal(sel) {
        const index = this.universal.findIndex(item => { var _a, _b; return ((_a = item.sel.ruleSet) === null || _a === void 0 ? void 0 : _a.hash) === ((_b = sel.ruleSet) === null || _b === void 0 ? void 0 : _b.hash); });
        if (index !== -1) {
            this.universal.splice(index);
        }
    }
    sortAsUniversal(sel) {
        this.universal.push(this.makeDocSelector(sel));
    }
    /**
     * add style selector to map
     *
     * @param map - style map
     * @param head - style key
     * @param sel - selector
     */
    addToMap(map, head, sel) {
        this.position += 1;
        const list = map[head];
        if (list) {
            list.push(this.makeDocSelector(sel));
        }
        else {
            map[head] = [this.makeDocSelector(sel)];
        }
    }
    makeDocSelector(sel) {
        this.position += 1;
        return { sel, pos: this.position };
    }
}

/*
 * Tencent is pleased to support the open source community by making
 * Hippy available.
 *
 * Copyright (C) 2022 THL A29 Limited, a Tencent company.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * determine if the value is null or undefined
 *
 * @param value - value
 */
function isNullOrUndefined(value) {
    return typeof value === 'undefined' || value === null;
}
/**
 * wrap string text
 *
 * @param text - string
 */
function wrap(text) {
    return text ? ` ${text}` : '';
}
/**
 * get node's parent node, in client side, node has parentNode props. in server side, find parentNode
 * by pId
 *
 * @param node - child node
 * @param ssrNodes - ssr node list
 *
 * @internal
 */
function getParentNode(node, ssrNodes) {
    if (ssrNodes) {
        // in server side mode, find parent node with pId
        if ((node === null || node === void 0 ? void 0 : node.pId) && ssrNodes[node.pId]) {
            return ssrNodes[node.pId];
        }
        return null;
    }
    return node === null || node === void 0 ? void 0 : node.parentNode;
}
/**
 * Base classes
 */
class SelectorCore {
    constructor() {
        // style weight
        this.specificity = 0;
    }
    /**
     * Sort and store style rules according to categories,
     * such as id selectors are grouped into one category, class names are grouped into one category, etc.
     *
     * @param sorter - sort rules
     * @param base - base
     */
    lookupSort(sorter, base) {
        sorter.sortAsUniversal(base !== null && base !== void 0 ? base : this);
    }
    /**
     * remove sort
     *
     * @param sorter - sort rules
     * @param base - base
     */
    removeSort(sorter, base) {
        sorter.removeAsUniversal(base !== null && base !== void 0 ? base : this);
    }
}
/**
 * Simple selector type
 * provides the method for judging whether a node matches and the method for tracking node attributes
 */
class SimpleSelector extends SelectorCore {
    constructor() {
        super(...arguments);
        // rarity of style
        this.rarity = 0;
    }
    accumulateChanges(node, match) {
        if (!this.dynamic) {
            return this.match(node);
        }
        if (this.mayMatch(node)) {
            this.trackChanges(node, match);
            return true;
        }
        return false;
    }
    /**
     * determine if the node matches
     *
     * @param node - target node
     */
    match(node) {
        return !!node;
    }
    /**
     * prejudgment
     *
     * @param node - target node
     */
    mayMatch(node) {
        return this.match(node);
    }
    /**
     * track changes of node
     *
     * @param node - target node
     * @param match - SelectorsMatch
     */
    trackChanges(node, match) {
    }
}
class SimpleSelectorSequence extends SimpleSelector {
    constructor(selectors) {
        super();
        this.specificity = selectors.reduce((sum, sel) => sel.specificity + sum, 0);
        this.head = selectors.reduce((prev, curr) => {
            return !prev
                || (prev instanceof SimpleSelector && curr.rarity > prev.rarity)
                ? curr
                : prev;
        }, null);
        this.dynamic = selectors.some(sel => sel.dynamic);
        this.selectors = selectors;
    }
    toString() {
        return `${this.selectors.join('')}${wrap(this.combinator)}`;
    }
    match(node) {
        if (!node) {
            return false;
        }
        return this.selectors.every(sel => sel.match(node));
    }
    mayMatch(node) {
        if (!node) {
            return false;
        }
        return this.selectors.every(sel => sel.mayMatch(node));
    }
    trackChanges(node, match) {
        this.selectors.forEach(sel => sel.trackChanges(node, match));
    }
    lookupSort(sorter, base) {
        if (this.head && this.head instanceof SimpleSelector) {
            this.head.lookupSort(sorter, base !== null && base !== void 0 ? base : this);
        }
    }
    removeSort(sorter, base) {
        if (this.head && this.head instanceof SimpleSelector) {
            this.head.removeSort(sorter, base !== null && base !== void 0 ? base : this);
        }
    }
}
/**
 * Generic selector type, eg. *
 */
class UniversalSelector extends SimpleSelector {
    constructor() {
        super();
        this.specificity = 0x00000000;
        this.rarity = 0;
        this.dynamic = false;
    }
    toString() {
        return `*${wrap(this.combinator)}`;
    }
    match() {
        // universal selectors can all match
        return true;
    }
}
/**
 * ID selector, eg. #root
 */
class IdSelector extends SimpleSelector {
    constructor(id) {
        super();
        this.specificity = 0x00010000;
        this.rarity = 3;
        this.dynamic = false;
        this.id = id;
    }
    toString() {
        return `#${this.id}${wrap(this.combinator)}`;
    }
    match(node) {
        var _a, _b;
        if (!node) {
            return false;
        }
        // ssr node's id is native id, the dom id is attribute's id
        return ((_b = (_a = node.props) === null || _a === void 0 ? void 0 : _a.attributes) === null || _b === void 0 ? void 0 : _b.id) === this.id || node.id === this.id;
    }
    lookupSort(sorter, base) {
        sorter.sortById(this.id, base !== null && base !== void 0 ? base : this);
    }
    removeSort(sorter, base) {
        sorter.removeById(this.id, base !== null && base !== void 0 ? base : this);
    }
}
/**
 * tag selector, eg. div, ul
 */
class TypeSelector extends SimpleSelector {
    constructor(cssType) {
        super();
        this.specificity = 0x00000001;
        this.rarity = 1;
        this.dynamic = false;
        this.cssType = cssType;
    }
    toString() {
        return `${this.cssType}${wrap(this.combinator)}`;
    }
    match(node) {
        if (!node) {
            return false;
        }
        return node.tagName === this.cssType;
    }
    lookupSort(sorter, base) {
        sorter.sortByType(this.cssType, base !== null && base !== void 0 ? base : this);
    }
    removeSort(sorter, base) {
        sorter.removeByType(this.cssType, base !== null && base !== void 0 ? base : this);
    }
}
/**
 * class selector
 */
class ClassSelector extends SimpleSelector {
    constructor(className) {
        super();
        this.specificity = 0x00000100;
        this.rarity = 2;
        this.dynamic = false;
        this.className = className;
    }
    toString() {
        return `.${this.className}${wrap(this.combinator)}`;
    }
    match(node) {
        var _a, _b, _c;
        if (!node) {
            return false;
        }
        // props and attributes exist means this node is generated from server side(except development).
        // so we need to use these props when we are ssr
        const classList = (_a = node.classList) !== null && _a !== void 0 ? _a : new Set((((_c = (_b = node.props) === null || _b === void 0 ? void 0 : _b.attributes) === null || _c === void 0 ? void 0 : _c.class) || '')
            .split(' ')
            .filter(x => x.trim()));
        return !!(classList.size && classList.has(this.className));
    }
    lookupSort(sorter, base) {
        sorter.sortByClass(this.className, base !== null && base !== void 0 ? base : this);
    }
    removeSort(sorter, base) {
        sorter.removeByClass(this.className, base !== null && base !== void 0 ? base : this);
    }
}
/**
 * pseudo class selector, not currently supported
 */
class PseudoClassSelector extends SimpleSelector {
    constructor(cssPseudoClass) {
        super();
        this.specificity = 0x00000100;
        this.rarity = 0;
        this.dynamic = true;
        this.cssPseudoClass = cssPseudoClass;
    }
    toString() {
        return `:${this.cssPseudoClass}${wrap(this.combinator)}`;
    }
    match() {
        return false;
    }
    mayMatch() {
        return true;
    }
    trackChanges(node, match) {
        match.addPseudoClass(node, this.cssPseudoClass);
    }
}
/**
 * get node attribute or styleScopeId value
 * @param node
 * @param attribute
 * @returns {*}
 */
const getNodeAttrVal = (node, attribute) => {
    var _a, _b, _c;
    // node.props is ssrNode's attributes list
    const attr = ((_a = node === null || node === void 0 ? void 0 : node.props) === null || _a === void 0 ? void 0 : _a[attribute]) || ((_b = node === null || node === void 0 ? void 0 : node.attributes) === null || _b === void 0 ? void 0 : _b[attribute]);
    if (typeof attr !== 'undefined') {
        return attr;
    }
    if (Array.isArray(node === null || node === void 0 ? void 0 : node.styleScopeId) && ((_c = node === null || node === void 0 ? void 0 : node.styleScopeId) === null || _c === void 0 ? void 0 : _c.includes(attribute))) {
        return attribute;
    }
};
/**
 * Attribute Selector
 */
class AttributeSelector extends SimpleSelector {
    // eslint-disable-next-line complexity
    constructor(attribute, test = '', value = '') {
        super();
        // attribute of node
        this.attribute = '';
        // property Test Conditions
        this.test = '';
        // value of node
        this.value = '';
        this.specificity = 0x00000100;
        this.rarity = 0;
        this.dynamic = true;
        this.attribute = attribute;
        this.test = test;
        this.value = value;
        if (!test) {
            // HasAttribute
            this.match = (node) => {
                if (!node || (!(node === null || node === void 0 ? void 0 : node.attributes) && !(node === null || node === void 0 ? void 0 : node.props))) {
                    // in client side render, node not exist or do not have attributes props means no attribute
                    // in server side render, node do not have attribute in props means no attribute
                    return false;
                }
                return !isNullOrUndefined(getNodeAttrVal(node, attribute));
            };
            return;
        }
        if (!value) {
            this.match = () => false;
            return;
        }
        this.match = (node) => {
            // props and attributes exist means this node is generated from server side(except development).
            // so we need to use these props when we are ssr
            if (!node || (!(node === null || node === void 0 ? void 0 : node.attributes) && !(node === null || node === void 0 ? void 0 : node.props[attribute]))) {
                return false;
            }
            const attr = `${getNodeAttrVal(node, attribute)}`;
            if (test === '=') {
                // Equal
                return attr === value;
            }
            if (test === '^=') {
                // PrefixMatch
                return attr.startsWith(value);
            }
            if (test === '$=') {
                // SuffixMatch
                return attr.endsWith(value);
            }
            if (test === '*=') {
                // SubstringMatch
                return attr.indexOf(value) !== -1;
            }
            if (test === '~=') {
                // Includes
                const words = attr.split(' ');
                return (words === null || words === void 0 ? void 0 : words.indexOf(value)) !== -1;
            }
            if (test === '|=') {
                // DashMatch
                return attr === value || attr.startsWith(`${value}-`);
            }
            return false;
        };
    }
    toString() {
        return `[${this.attribute}${wrap(this.test)}${(this.test && this.value) || ''}]${wrap(this.combinator)}`;
    }
    /**
     * return false
     *
     * @param node - target node
     */
    match(node) {
        return node ? !node : false;
    }
    mayMatch() {
        return true;
    }
    trackChanges(node, match) {
        match.addAttribute(node, this.attribute);
    }
}
/**
 * Invalid Selector
 */
class InvalidSelector extends SimpleSelector {
    constructor(error) {
        super();
        this.specificity = 0x00000000;
        this.rarity = 4;
        this.dynamic = false;
        this.combinator = undefined;
        this.error = error;
    }
    toString() {
        return `<error: ${this.error}>`;
    }
    match() {
        return false;
    }
    lookupSort() {
        return null;
    }
    removeSort() {
        return null;
    }
}
/**
 * child node group
 */
class ChildGroup {
    constructor(selectors) {
        this.selectors = selectors;
        this.dynamic = selectors.some(sel => sel.dynamic);
    }
    match(node) {
        if (!node) {
            return false;
        }
        const pass = this.selectors.every((sel, i) => {
            if (i !== 0) {
                node = node.parentNode;
            }
            return !!node && sel.match(node);
        });
        return pass ? node : null;
    }
    mayMatch(node) {
        if (!node) {
            return false;
        }
        const pass = this.selectors.every((sel, i) => {
            if (i !== 0) {
                node = node.parentNode;
            }
            return !!node && sel.mayMatch(node);
        });
        return pass ? node : null;
    }
    trackChanges(node, map) {
        this.selectors.forEach((sel, i) => {
            if (i !== 0) {
                node = node.parentNode;
            }
            if (!node) {
                return;
            }
            sel.trackChanges(node, map);
        });
    }
}
/**
 * Sibling node group
 */
class SiblingGroup {
    constructor(selectors) {
        this.selectors = selectors;
        this.dynamic = selectors.some(sel => sel.dynamic);
    }
    match(node) {
        if (!node) {
            return false;
        }
        const pass = this.selectors.every((sel, i) => {
            if (i !== 0) {
                node = node.nextSibling;
            }
            return !!node && sel.match(node);
        });
        return pass ? node : null;
    }
    mayMatch(node) {
        if (!node) {
            return false;
        }
        const pass = this.selectors.every((sel, i) => {
            if (i !== 0) {
                node = node.nextSibling;
            }
            return !!node && sel.mayMatch(node);
        });
        return pass ? node : null;
    }
    trackChanges(node, map) {
        this.selectors.forEach((sel, i) => {
            if (i !== 0) {
                node = node.nextSibling;
            }
            if (!node) {
                return;
            }
            sel.trackChanges(node, map);
        });
    }
}
/**
 * selector class
 */
class Selector extends SelectorCore {
    constructor(selectors) {
        super();
        const supportedCombinator = [undefined, ' ', '>', '+', '~'];
        let siblingGroup = [];
        let lastGroup = [];
        const groups = [];
        const selectorList = [...selectors];
        const length = selectorList.length - 1;
        this.specificity = 0;
        this.dynamic = false;
        for (let i = length; i >= 0; i--) {
            const sel = selectorList[i];
            if (supportedCombinator.indexOf(sel.combinator) === -1) {
                console.error(`Unsupported combinator "${sel.combinator}".`);
                throw new Error(`Unsupported combinator "${sel.combinator}".`);
            }
            if (sel.combinator === undefined || sel.combinator === ' ') {
                groups.push(lastGroup = [(siblingGroup = [])]);
            }
            if (sel.combinator === '>') {
                lastGroup.push((siblingGroup = []));
            }
            this.specificity += sel.specificity;
            if (sel.dynamic) {
                this.dynamic = true;
            }
            siblingGroup.push(sel);
        }
        this.groups = groups.map(g => new ChildGroup(g.map(sg => new SiblingGroup(sg))));
        this.last = selectorList[length];
    }
    toString() {
        return this.selectors.join('');
    }
    match(node, ssrNodes) {
        if (!node) {
            return false;
        }
        return this.groups.every((group, i) => {
            if (i === 0) {
                node = group.match(node);
                return !!node;
            }
            let ancestor = getParentNode(node, ssrNodes);
            while (ancestor) {
                if ((node = group.match(ancestor))) {
                    return true;
                }
                ancestor = getParentNode(ancestor, ssrNodes);
            }
            return false;
        });
    }
    lookupSort(sorter) {
        this.last.lookupSort(sorter, this);
    }
    removeSort(sorter) {
        this.last.removeSort(sorter, this);
    }
    accumulateChanges(node, map, ssrNodes) {
        if (!this.dynamic) {
            return this.match(node, ssrNodes);
        }
        const bounds = [];
        const mayMatch = this.groups.every((group, i) => {
            if (i === 0) {
                const nextNode = group.mayMatch(node);
                bounds.push({ left: node, right: node });
                node = nextNode;
                return !!node;
            }
            let ancestor = getParentNode(node, ssrNodes);
            while (ancestor) {
                const nextNode = group.mayMatch(ancestor);
                if (nextNode) {
                    bounds.push({ left: ancestor, right: null });
                    node = nextNode;
                    return true;
                }
                ancestor = getParentNode(ancestor, ssrNodes);
            }
            return false;
        });
        // Calculating the right bounds for each selector won't save much
        if (!mayMatch) {
            return false;
        }
        if (!map) {
            return mayMatch;
        }
        for (let i = 0; i < this.groups.length; i += 1) {
            const group = this.groups[i];
            if (!group.dynamic) {
                continue;
            }
            const bound = bounds[i];
            let node = bound.left;
            do {
                if (group.mayMatch(node)) {
                    group.trackChanges(node, map);
                }
            } while (node !== bound.right
                && (node = node.parentNode));
        }
        return mayMatch;
    }
}
/**
 * Rule Set
 */
class RuleSet {
    constructor(selectors, declarations, hash) {
        selectors.forEach((sel) => {
            sel.ruleSet = this; // FIXME: It makes circular dependency
            return null;
        });
        this.selectors = selectors;
        this.declarations = declarations;
        this.hash = hash;
    }
    toString() {
        return `${this.selectors.join(', ')} {${this.declarations
            .map((d, i) => `${i === 0 ? ' ' : ''}${d.property}: ${d.value}`)
            .join('; ')}}`;
    }
    lookupSort(sorter) {
        this.selectors.forEach(sel => sel.lookupSort(sorter));
    }
    removeSort(sorter) {
        this.selectors.forEach(sel => sel.removeSort(sorter));
    }
}

// Check the Regexp is support sticky flag.
const REGEXP_SUPPORTING_STICKY_FLAG = (() => {
    try {
        return !!new RegExp('foo', 'y');
    }
    catch (err) {
        return false;
    }
})();
// Regexp strings
const REGEXP_STRINGS = {
    whiteSpaceRegEx: '\\s*',
    universalSelectorRegEx: '\\*',
    simpleIdentifierSelectorRegEx: '(#|\\.|:|\\b)([_-\\w][_-\\w\\d]*)',
    attributeSelectorRegEx: '\\[\\s*([_-\\w][_-\\w\\d]*)\\s*(?:(=|\\^=|\\$=|\\*=|\\~=|\\|=)\\s*(?:([_-\\w][_-\\w\\d]*)|"((?:[^\\\\"]|\\\\(?:"|n|r|f|\\\\|0-9a-f))*)"|\'((?:[^\\\\\']|\\\\(?:\'|n|r|f|\\\\|0-9a-f))*)\')\\s*)?\\]',
    combinatorRegEx: '\\s*(\\+|~|>)?\\s*',
};
// RegExp instance cache
const REGEXPS = {};
// Execute the RegExp
function execRegExp(regexpKey, text, start) {
    let flags = '';
    // Check the sticky flag supporting, and cache the RegExp instance.
    if (REGEXP_SUPPORTING_STICKY_FLAG) {
        flags = 'gy';
    }
    if (!REGEXPS[regexpKey]) {
        REGEXPS[regexpKey] = new RegExp(REGEXP_STRINGS[regexpKey], flags);
    }
    const regexp = REGEXPS[regexpKey];
    let result;
    // Fallback to split the text if sticky is not supported.
    if (REGEXP_SUPPORTING_STICKY_FLAG) {
        regexp.lastIndex = start;
        result = regexp.exec(text);
    }
    else {
        // eslint-disable-next-line no-param-reassign
        text = text.slice(start, text.length);
        result = regexp.exec(text);
        if (!result) {
            return {
                result: null,
                regexp,
            };
        }
        // add start index to prevent infinite loop caused by class name like .aa_bb.aa
        regexp.lastIndex = start + result[0].length;
    }
    return {
        result,
        regexp,
    };
}
function parseUniversalSelector(text, start) {
    const { result, regexp } = execRegExp('universalSelectorRegEx', text, start);
    if (!result) {
        return null;
    }
    const end = regexp.lastIndex;
    return {
        value: {
            type: '*',
        },
        start,
        end,
    };
}
function parseSimpleIdentifierSelector(text, start) {
    const { result, regexp } = execRegExp('simpleIdentifierSelectorRegEx', text, start);
    if (!result) {
        return null;
    }
    const end = regexp.lastIndex;
    const type = result[1];
    const identifier = result[2];
    const value = { type, identifier };
    return {
        value,
        start,
        end,
    };
}
function parseAttributeSelector(text, start) {
    const { result, regexp } = execRegExp('attributeSelectorRegEx', text, start);
    if (!result) {
        return null;
    }
    const end = regexp.lastIndex;
    const property = result[1];
    if (result[2]) {
        const test = result[2];
        const value = result[3] || result[4] || result[5];
        return {
            value: {
                type: '[]',
                property,
                test,
                value,
            },
            start,
            end,
        };
    }
    return {
        value: {
            type: '[]',
            property,
        },
        start,
        end,
    };
}
function parseSimpleSelector(text, start) {
    var _a, _b;
    return ((_b = (_a = parseUniversalSelector(text, start)) !== null && _a !== void 0 ? _a : parseSimpleIdentifierSelector(text, start)) !== null && _b !== void 0 ? _b : parseAttributeSelector(text, start));
}
function parseSimpleSelectorSequence(text, start) {
    let simpleSelector = parseSimpleSelector(text, start);
    if (!simpleSelector) {
        return null;
    }
    let { end } = simpleSelector;
    const value = [];
    while (simpleSelector) {
        value.push(simpleSelector.value);
        ({ end } = simpleSelector);
        simpleSelector = parseSimpleSelector(text, end);
    }
    return {
        start,
        end,
        value,
    };
}
function parseCombinator(text, start) {
    const { result, regexp } = execRegExp('combinatorRegEx', text, start);
    if (!result) {
        return null;
    }
    let end;
    if (REGEXP_SUPPORTING_STICKY_FLAG) {
        end = regexp.lastIndex;
    }
    else {
        end = start;
    }
    const value = result[1] || ' ';
    return {
        start,
        end,
        value,
    };
}
/**
 * parse the selector
 * after parsing：
 * 1、end is the index of the position where the selector ends
 * 2、start is the specified start position
 * 3、value is the value of the selector, including type: such as id selector, class selector, etc.
 *
 * @param text - selector content
 * @param start - starting position
 */
function parseSelector(text, start) {
    let end = start;
    const { result, regexp } = execRegExp('whiteSpaceRegEx', text, start);
    if (result) {
        end = regexp.lastIndex;
    }
    const value = [];
    let combinator;
    let expectSimpleSelector = true;
    let pair = [undefined, undefined];
    let cssText;
    if (REGEXP_SUPPORTING_STICKY_FLAG) {
        cssText = [text];
    }
    else {
        cssText = text.split(' ');
    }
    cssText.forEach((newText) => {
        if (!REGEXP_SUPPORTING_STICKY_FLAG) {
            if (newText === '') {
                return;
            }
            end = 0;
        }
        do {
            const simpleSelectorSequence = parseSimpleSelectorSequence(newText, end);
            if (!simpleSelectorSequence) {
                if (expectSimpleSelector) {
                    return;
                }
                break;
            }
            ({ end } = simpleSelectorSequence);
            if (combinator) {
                pair[1] = combinator.value;
            }
            pair = [simpleSelectorSequence.value, undefined];
            value.push(pair);
            combinator = parseCombinator(newText, end);
            if (combinator) {
                ({ end } = combinator);
            }
            expectSimpleSelector = !!(combinator && combinator.value !== ' ');
        } while (combinator);
    });
    return {
        start,
        end,
        value,
    };
}

/*
 * Tencent is pleased to support the open source community by making
 * Hippy available.
 *
 * Copyright (C) 2022 THL A29 Limited, a Tencent company.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// style load hook
const beforeLoadStyleHook = (declaration) => declaration;
function isDeclaration(node) {
    return node.type === 'declaration';
}
function createDeclaration(beforeLoadStyle) {
    return (decl) => {
        const newDecl = beforeLoadStyle(decl);
        if (process.env.NODE_ENV !== 'production') {
            if (!newDecl) {
                throw new Error('beforeLoadStyle hook must returns the processed style object');
            }
        }
        return newDecl;
    };
}
function createSimpleSelectorFromAst(ast) {
    switch (ast.type) {
        case '*':
            return new UniversalSelector();
        case '#':
            return new IdSelector(ast.identifier);
        case '':
            return new TypeSelector(ast.identifier.replace(/-/, '').toLowerCase());
        case '.':
            return new ClassSelector(ast.identifier);
        case ':':
            return new PseudoClassSelector(ast.identifier);
        case '[]':
            return ast.test
                ? new AttributeSelector(ast.property, ast.test, ast.value)
                : new AttributeSelector(ast.property);
        default:
            return null;
    }
}
function createSimpleSelectorSequenceFromAst(ast) {
    if (ast.length === 0) {
        return new InvalidSelector(new Error('Empty simple selector sequence.'));
    }
    if (ast.length === 1) {
        return createSimpleSelectorFromAst(ast[0]);
    }
    return new SimpleSelectorSequence(ast.map(createSimpleSelectorFromAst));
}
function createSelectorFromAst(ast) {
    if (ast.length === 0) {
        return new InvalidSelector(new Error('Empty selector.'));
    }
    if (ast.length === 1) {
        return createSimpleSelectorSequenceFromAst(ast[0][0]);
    }
    const simpleSelectorSequences = [];
    for (const currentAst of ast) {
        const simpleSelectorSequence = createSimpleSelectorSequenceFromAst(currentAst[0]);
        const combinator = currentAst[1];
        if (combinator && simpleSelectorSequence) {
            simpleSelectorSequence.combinator = combinator;
        }
        simpleSelectorSequences.push(simpleSelectorSequence);
    }
    return new Selector(simpleSelectorSequences);
}
function createSelector(sel) {
    try {
        const parsedSelector = parseSelector(sel, 0);
        if (!parsedSelector) {
            return new InvalidSelector(new Error('Empty selector'));
        }
        return createSelectorFromAst(parsedSelector.value);
    }
    catch (e) {
        return new InvalidSelector(e);
    }
}
/**
 * transform css ast to style rule set
 *
 * @param astRules - css ast list
 * @param beforeLoadStyle
 */
function fromAstNodes(astRules = [], beforeLoadStyle) {
    return astRules.map((rule) => {
        const declarations = rule.declarations
            .filter(isDeclaration)
            // use default hook when there is no hook passed in
            .map(createDeclaration(beforeLoadStyle !== null && beforeLoadStyle !== void 0 ? beforeLoadStyle : beforeLoadStyleHook));
        const selectors = rule.selectors.map(createSelector);
        return new RuleSet(selectors, declarations, rule.hash);
    });
}
/**
 * transform css ast from server side to style rule set
 *
 * @param ssrAstRules - css ast rule list from server
 * @param beforeLoadStyle
 */
function fromSsrAstNodes(ssrAstRules = [], beforeLoadStyle) {
    return ssrAstRules.map((rule) => {
        // style from server was simplified. index '0' means attribute 'selectors', index '1' means
        // 'declarations'
        // ex: [['.class'], [['width', '100px']]] => { selectors: ['.class'], 'declarations': [['width', '100px']] }
        let selectors = rule[0];
        let declarations = rule[1];
        // we need to revert simplified key to raw key
        declarations = declarations
            .map((declaration) => {
            const [property, value] = declaration;
            return {
                type: 'declaration',
                property,
                value,
            };
        })
            // use default hook when there is no hook passed in
            .map(createDeclaration(beforeLoadStyle !== null && beforeLoadStyle !== void 0 ? beforeLoadStyle : beforeLoadStyleHook));
        // create style class
        selectors = selectors.map(createSelector);
        // ssr style no hash
        return new RuleSet(selectors, declarations, '');
    });
}
// global css map
let globalCssMap;
/**
 * judge css map is empty, undefined or no ruleset is empty
 *
 * @param cssMap
 */
function isEmptyCssMap(cssMap) {
    var _a;
    return !cssMap || !((_a = cssMap === null || cssMap === void 0 ? void 0 : cssMap.ruleSets) === null || _a === void 0 ? void 0 : _a.length);
}
/**
 * get css map
 *
 * @param styles - style list
 * @param beforeLoadStyle - before load style hook
 * @public
 */
function getCssMap(styles, beforeLoadStyle) {
    // have styles params means ssr, so we used styles as global css map
    if (styles) {
        if (!isEmptyCssMap(globalCssMap)) {
            return globalCssMap;
        }
        // get ssr ast nodes
        const cssRules = fromSsrAstNodes(styles, beforeLoadStyle);
        globalCssMap = new SelectorsMap(cssRules);
        return globalCssMap;
    }
    // no styles params means csr, we used global css map as before
    const styleCssMap = global[HIPPY_GLOBAL_STYLE_NAME];
    /**
     * To support dynamic import, globalCssMap can be loaded from different js file.
     * globalCssMap should be created/appended if global[GLOBAL_STYLE_NAME] exists;
     */
    if (isEmptyCssMap(globalCssMap) || styleCssMap) {
        /**
         *  Here is a secret startup option: beforeStyleLoadHook.
         *  Usage for process the styles while styles loading.
         */
        const cssRules = fromAstNodes(styleCssMap, beforeLoadStyle);
        if (globalCssMap) {
            globalCssMap.append(cssRules);
        }
        else {
            globalCssMap = new SelectorsMap(cssRules);
        }
        // after the global style processing is complete, remove the value of this object
        global[HIPPY_GLOBAL_STYLE_NAME] = undefined;
    }
    // if there are currently expired styles, hot update style processing
    if (global[HIPPY_GLOBAL_DISPOSE_STYLE_NAME]) {
        // the new css style will be generated with hash id, so it can be removed by id
        global[HIPPY_GLOBAL_DISPOSE_STYLE_NAME].forEach((id) => {
            // remove outdated styles
            globalCssMap.delete(id);
        });
        // remove saved expired styles
        global[HIPPY_GLOBAL_DISPOSE_STYLE_NAME] = undefined;
    }
    return globalCssMap;
}

/*
 * Tencent is pleased to support the open source community by making
 * Hippy available.
 *
 * Copyright (C) 2022 THL A29 Limited, a Tencent company.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// regular expression of number format
const numberRegEx = new RegExp('^(?=.+)[+-]?\\d{0,17}\\.?\\d{0,5}([Ee][+-]?\\d{1,5})?$');
/**
 * Convert strings to number as much as possible
 */
function tryConvertNumber(str) {
    if (typeof str === 'number') {
        return str;
    }
    if (numberRegEx.test(str)) {
        try {
            return parseFloat(str);
        }
        catch (err) {
            // pass
        }
    }
    return str;
}
/**
 * covert rem style to native pt, support custom base width
 *
 * @param styleValue - css style value
 * @param ratioBaseWidth - base width of design draft, default is 750px
 */
function convertRemValue(styleValue, ratioBaseWidth) {
    var _a, _b;
    let value = styleValue;
    // do not convert non rem value
    if (typeof value !== 'string' || !value.endsWith('rem')) {
        return value;
    }
    // get rem number
    value = parseFloat(value);
    // direct return is non number
    if (Number.isNaN(value)) {
        return value;
    }
    // default width of design draft
    const defaultRatioBaseWidth = 750;
    const { width } = (_b = (_a = global === null || global === void 0 ? void 0 : global.Hippy) === null || _a === void 0 ? void 0 : _a.device) === null || _b === void 0 ? void 0 : _b.screen;
    if (width) {
        const ratio = width / (ratioBaseWidth !== null && ratioBaseWidth !== void 0 ? ratioBaseWidth : defaultRatioBaseWidth);
        return value * 100 * ratio;
    }
    // direct return when do not have screen size
    return value;
}
/**
 * get default style for native node
 *
 * @param node - ssr node
 */
function getDefaultNativeStyle(node) {
    if (node.name === 'Image') {
        return { backgroundColor: 0 };
    }
    if (node.name === 'ListView') {
        // Necessary by iOS
        return { flex: 1 };
    }
    if (node.name === 'Text') {
        // text node, for label,span,p. Black color(#000), necessary for Android
        // text node, for a, Blue color(rgb(0, 0, 238), necessary for Android
        return { color: node.tagName === 'a' ? 4278190318 : 4278190080 };
    }
    if (node.name === 'TextInput') {
        return {
            padding: 0,
            color: 4278190080, // Black color(#000), necessary for Android
        };
    }
    if (node.name === 'ViewPagerItem') {
        // swiper-slide item
        return {
            position: 'absolute',
            top: 0,
            right: 0,
            bottom: 0,
            left: 0,
        };
    }
    if (node.name === 'Modal') {
        // dialog
        return {
            position: 'absolute',
        };
    }
    // nothing for other
    return {};
}
/**
 * Handle special cases of some native node
 *
 * @param node - hippy node
 * @param scrollViewContainerIdList - the id for scrollView's wrapper
 */
function polyfillSpecialNodeStyle(node, scrollViewContainerIdList) {
    const nativeNode = node;
    const currentScrollViewContainerIdList = scrollViewContainerIdList;
    const style = node.props.style || {};
    if (node.name === 'View') {
        // View do not scroll, so we should change to ScrollView when props have overflow: scroll
        if (style.overflowY === 'scroll') {
            nativeNode.name = 'ScrollView';
        }
        else if (style.overflowX === 'scroll') {
            nativeNode.name = 'ScrollView';
            // should set horizontal for horizontal scroll
            nativeNode.props.horizontal = true;
            // ssr default set to row, updated at client side
            style.flexDirection = 'row';
        }
        // compatible nativeBackgroundAndroid style props
        const { nativeBackgroundAndroid } = nativeNode.props;
        if (nativeBackgroundAndroid && typeof nativeBackgroundAndroid.color !== 'undefined') {
            nativeNode.props.nativeBackgroundAndroid.color = translateColor(nativeBackgroundAndroid.color);
        }
    }
    // Change the ScrollView child collapsable attribute
    if (nativeNode.name === 'ScrollView') {
        currentScrollViewContainerIdList[nativeNode.id] = [];
    }
    // if parent node is ScrollView, child node must set collapsable to false
    if (nativeNode === null || nativeNode === void 0 ? void 0 : nativeNode.pId) {
        if (currentScrollViewContainerIdList[nativeNode.pId]) {
            if (currentScrollViewContainerIdList[nativeNode.pId].length > 0) {
                // eslint-disable-next-line no-console
                console.warn('Only one child node is acceptable for View with overflow');
            }
            else {
                currentScrollViewContainerIdList[nativeNode.pId] = [Number(nativeNode.id)];
                nativeNode.props.style.collapsable = false;
            }
        }
    }
    // compatible Input
    if (nativeNode.name === 'TextInput') {
        ['caretColor', 'underlineColorAndroid', 'placeholderTextColor'].forEach((key) => {
            if (nativeNode.props[key] && typeof nativeNode.props[key] !== 'number') {
                nativeNode.props[key] = translateColor(nativeNode.props[key]);
            }
        });
    }
    return node;
}
/**
 * 获取 item 匹配的 hippy css 样式
 *
 * @param selectors - 匹配的选择器列表
 */
function getItemHippyCssStyle(selectors) {
    var _a, _b;
    const style = {};
    // if selectors exist, doing value put
    if (selectors === null || selectors === void 0 ? void 0 : selectors.length) {
        // eslint-disable-next-line @typescript-eslint/prefer-for-of
        for (let i = 0; i < selectors.length; i++) {
            const selector = selectors[i];
            if ((_b = (_a = selector.ruleSet) === null || _a === void 0 ? void 0 : _a.declarations) === null || _b === void 0 ? void 0 : _b.length) {
                const { declarations } = selector.ruleSet;
                // eslint-disable-next-line @typescript-eslint/prefer-for-of
                for (let j = 0; j < declarations.length; j++) {
                    const declaration = declarations[j];
                    if (declaration.property) {
                        style[declaration.property] = declaration.value;
                    }
                }
            }
        }
    }
    return style;
}
/**
 * parse text shadow offset
 *
 * @param property - property name
 * @param value - property value
 * @param rawStyle - original style
 *
 */
function parseTextShadowOffset(property, value = 0, rawStyle) {
    var _a;
    const style = rawStyle;
    const offsetMap = {
        textShadowOffsetX: 'width',
        textShadowOffsetY: 'height',
    };
    style.textShadowOffset = (_a = style.textShadowOffset) !== null && _a !== void 0 ? _a : {};
    Object.assign(style.textShadowOffset, {
        [offsetMap[property]]: value,
    });
    return ['textShadowOffset', style.textShadowOffset];
}
function parseItemStyle(styleObject) {
    var _a;
    const itemStyle = {};
    for (let [styleProperty, styleValue] of Object.entries(styleObject)) {
        // Process the specific style value
        switch (styleProperty) {
            case 'fontWeight':
                if (typeof styleValue !== 'string') {
                    styleValue = styleValue.toString();
                }
                break;
            case 'backgroundImage': {
                [styleProperty, styleValue] = parseBackgroundImage(styleProperty, styleValue);
                break;
            }
            case 'textShadowOffsetX':
            case 'textShadowOffsetY': {
                [styleProperty, styleValue] = parseTextShadowOffset(styleProperty, styleValue, styleObject);
                break;
            }
            case 'textShadowOffset': {
                const { x = 0, width = 0, y = 0, height = 0 } = (_a = styleValue) !== null && _a !== void 0 ? _a : {};
                styleValue = { width: x || width, height: y || height };
                break;
            }
            default: {
                // Convert the property to W3C standard.
                if (Object.prototype.hasOwnProperty.call(PROPERTIES_MAP, styleProperty)) {
                    styleProperty = PROPERTIES_MAP[styleProperty];
                }
                // Convert the value
                if (typeof styleValue === 'string') {
                    let value = styleValue.trim();
                    // Convert inline color style to int
                    if (styleProperty.toLowerCase().indexOf('color') >= 0) {
                        value = translateColor(styleValue);
                        // Convert inline length style, drop the px unit
                    }
                    else if (styleValue.endsWith('px')) {
                        value = parseFloat(styleValue.slice(0, styleValue.length - 2));
                    }
                    else if (styleValue.endsWith('rem')) {
                        value = convertRemValue(styleValue);
                    }
                    else {
                        value = tryConvertNumber(styleValue);
                    }
                    styleValue = value;
                }
            }
        }
        // assign parsed style value
        itemStyle[styleProperty] = styleValue;
    }
    return itemStyle;
}
/**
 * insert style for ssr nodes
 *
 * @param nodeList - ssr node list
 * @param styleContent - style content
 *
 * @public
 */
function insertStyleForSsrNodes(nodeList, styleContent) {
    // transform hippy node list to object.
    // for example: [ { id: 1, name: 'a' }, { id: 2, name: 'b' } ]
    //   => { 1: { id: 1, name: 'a' }, 2: { id: 2, name: 'b' } }
    const ssrNodes = Object.fromEntries(nodeList.map(item => [item.id, item]));
    // get css match map
    const cssMap = getCssMap(styleContent);
    // get scrollView's wrapper id, should handle later
    const scrollViewContainerIdList = {};
    // insert style for every node
    return nodeList.map((item) => {
        // find matched selectors
        const matchedSelectors = cssMap.query(item, ssrNodes);
        // parse css style sheet
        const style = parseItemStyle(getItemHippyCssStyle(matchedSelectors.selectors));
        // get component default style
        const defaultNativeStyle = getDefaultNativeStyle(item);
        // handle item style
        const originalInnerStyle = {};
        let hasInnerStyle = false;
        if (item.props.style) {
            const keys = Object.keys(item.props.style);
            // parse inner style when exist
            if (keys.length) {
                hasInnerStyle = true;
                keys.forEach((key) => {
                    const camelKey = camelize(key);
                    // save original inner style
                    originalInnerStyle[camelKey] = item.props.style[key];
                });
            }
        }
        // inner style is the top priority, save to use later
        item.props.inlineStyle = hasInnerStyle
            ? parseItemStyle(originalInnerStyle)
            : {};
        // current used style, include default style, style sheet and inline style
        item.props.style = Object.assign(defaultNativeStyle, style, item.props.inlineStyle);
        // polyfill special node
        return polyfillSpecialNodeStyle(item, scrollViewContainerIdList);
    });
}

/**
 * global style name
 *
 * @public
 */
const HIPPY_GLOBAL_STYLE_NAME = '__HIPPY_VUE_STYLES__';
/**
 * need delete style list, when we used hmr, expired style will be push to globally dispose array
 *
 * @public
 */
const HIPPY_GLOBAL_DISPOSE_STYLE_NAME = '__HIPPY_VUE_DISPOSE_STYLES__';

export { HIPPY_GLOBAL_DISPOSE_STYLE_NAME, HIPPY_GLOBAL_STYLE_NAME, PROPERTIES_MAP, SelectorsMap, convertToDegree, getCssMap, getLinearGradientAngle, getLinearGradientColorStop, insertStyleForSsrNodes, parseBackgroundImage, parseCSS, translateColor };
